
package net.ligent.students.transportation;

public class ArrayBasedVehicleTestDataSource {

	/*
	 * To properly configure this test data source, 
	 * increase NUMBER_OF_VEHICLES initialized value
	 * to include all test vehicle instances created below.
	 */
	public static final int NUMBER_OF_VEHICLES = 10;

	private Vehicle[] vehicles = new Vehicle[NUMBER_OF_VEHICLES];
	private int nextAvailableIndex = 0;
	private boolean isExhausted = false;

	public ArrayBasedVehicleTestDataSource() {
		super();
		initializeVehicleArray();
	}

	private void initializeVehicleArray() {
		/*
		 * To properly configure this test data source, create 5
		 * instances of each Vehicle subtype and store them in the array.
		 */

		// Cars
		vehicles[0] = new Car("Ford", "Mustang", 1966, "Green", Car.GAS, "A123456");
		vehicles[1] = new Car("Ford", "Falcon", 1965, "White/Teal", Car.GAS, "A234567");
		vehicles[2] = new Car("Oldsmobile", "Delta 88", 1972, "Blue", Car.GAS, "A345678");
		vehicles[3] = new Car("Vokswagen", "Golf", 2013, "Gold", Car.DIESEL, "A456789");
		vehicles[4] = new Car("Tesla", "Model S", 2016, "Red", Car.ELECTRIC, "A567890");
		
		// Motorcycles
		vehicles[5] = new Motorcycle("BMW", "Pipsqueak", 2011, "Black", 300, "M11111");
		vehicles[6] = new Motorcycle("BMW", "Funbike", 2012, "Red", 750, "M22222");
		vehicles[7] = new Motorcycle("BMW", "Fastbike", 2013, "Black", 1199, "M33333");
		vehicles[8] = new Motorcycle("BMW", "Bigbike", 2014, "Black", 1250, "M44444");
		vehicles[9] = new Motorcycle("BMW", "Uberbike", 2015, "Black", 1600, "M55555");
	}

	public Vehicle getNextVehicle() {
		Vehicle answer;
		if (isExhausted) {
			answer = null;
		} else {
			answer = vehicles[nextAvailableIndex];
			if (nextAvailableIndex == (NUMBER_OF_VEHICLES - 1)) {
				isExhausted = true;
			} else {
				nextAvailableIndex++;
			}
		}
		return answer;
	}

}
