package net.ligent.students.transportation;

public class Boat {

	// instance variables
	String make;
	String model;
	int year;
	String color;
	int length;
	String vehicleIdNumber;
	
	// constructors
	
	public Boat() {
		// no-argument constructor
	}

	public Boat(String expectedMake, String expectedModel, int expectedYear, String expectedColor, int expectedLength,
			String expectedVehicleIdNumber) {
		setMake(expectedMake);
		setModel(expectedModel);
		setYear(expectedYear);
		setColor(expectedColor);
		setLength(expectedLength);
		setVehicleIdNumber(expectedVehicleIdNumber);
	}

	public Boat(String expectedMake, String expectedModel, int expectedYear, String expectedColor, int expectedLength) {
		this(expectedMake,
			 expectedModel,
			 expectedYear,
			 expectedColor,
			 expectedLength,
			 null);
	}

	// getters and setters
	public String getMake() {
		return make;
	}

	public void setMake(String make) {
		this.make = make;
	}

	public String getModel() {
		return model;
	}

	public void setModel(String model) {
		this.model = model;
	}

	public int getYear() {
		return year;
	}

	public void setYear(int year) {
		this.year = year;
	}

	public String getColor() {
		return color;
	}

	public void setColor(String color) {
		this.color = color;
	}

	public int getLength() {
		return length;
	}

	public void setLength(int length) {
		this.length = length;
	}

	public String getVehicleIdNumber() {
		return vehicleIdNumber;
	}

	public void setVehicleIdNumber(String vehicleIdNumber) {
		this.vehicleIdNumber = vehicleIdNumber;
	}

	// other methods
	@Override
	public String toString() {
		return "Boat [make=" + make + ", model=" + model + ", year=" + year + ", color=" + color + ", length=" + length
				+ ", vehicleIdNumber=" + vehicleIdNumber + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((color == null) ? 0 : color.hashCode());
		result = prime * result + length;
		result = prime * result + ((make == null) ? 0 : make.hashCode());
		result = prime * result + ((model == null) ? 0 : model.hashCode());
		result = prime * result + year;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Boat other = (Boat) obj;
		if (color == null) {
			if (other.color != null)
				return false;
		} else if (!color.equals(other.color))
			return false;
		if (length != other.length)
			return false;
		if (make == null) {
			if (other.make != null)
				return false;
		} else if (!make.equals(other.make))
			return false;
		if (model == null) {
			if (other.model != null)
				return false;
		} else if (!model.equals(other.model))
			return false;
		if (year != other.year)
			return false;
		return true;
	}

	public double determineAnnualRegistrationFee() {
		double answer = 210.00;
		if (getLength() < 16) {
			answer = 28.00;
		} else if (getLength() < 27) {
			answer = 60.00;
		} else if (getLength() < 41) {
			answer = 160.00;
		}
		
		
		
		
		return answer;
	}
	
	
	

	
	

}
