package net.ligent.students.transportation;

public class Car extends Vehicle {

	private String fuelType;

	// class constants
	public static final String GAS = "Gas";
	public static final String DIESEL = "Diesel";
	public static final String ELECTRIC = "Electric";

	// constructors
	public Car() {
		// no-argument constructor
		super();
	}

	public Car(String make, String model, int year, String color, String fuelType, String vehicleIdNumber) {
		// overloaded constructor
		super(make, model, year, color, vehicleIdNumber);
		setFuelType(fuelType);
	}

	public Car(String expectedMake, String expectedModel, int expectedYear, String expectedColor,
			String expectedFuelType) {
		this(expectedMake, expectedModel, expectedYear, expectedColor, expectedFuelType, null);
	}

	public String getFuelType() {
		return fuelType;
	}

	public void setFuelType(String fuelType) {
		this.fuelType = fuelType;
	}

	// other (worker) methods

	@Override
	public String toString() {
		return "Car [fuelType=" + fuelType + ", " + super.toString() + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((fuelType == null) ? 0 : fuelType.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		Car other = (Car) obj;
		if (fuelType == null) {
			if (other.fuelType != null)
				return false;
		} else if (!fuelType.equals(other.fuelType))
			return false;
		return true;
	}

	public double determineAnnualRegistrationFee() {
		double answer = 0.00;
		if (getFuelType() == null) {
			answer = 150.00;
		} else if (getFuelType().equals(ELECTRIC)) {
			answer = 50.00;
		} else if (getFuelType().equals(GAS)) {
			answer = 100.00;
		} else {
			answer = 150.00;
		}
		return answer;
	}

}
