package net.ligent.students.transportation;

public class Motorcycle extends Vehicle {

	// instance variables
	private int engineDisplacementInCcs;

	// constructors

	public Motorcycle() {
		// no-argument constructor
		super();
	}

	public Motorcycle(String expectedMake, String expectedModel, int expectedYear, String expectedColor,
			int expectedEngineDisp, String expectedVehicleIdNumber) {
		// fully overloaded constructor
		super(expectedMake, expectedModel, expectedYear, expectedColor, expectedVehicleIdNumber);
		setEngineDisplacementInCcs(expectedEngineDisp);
	}

	public Motorcycle(String expectedMake, String expectedModel, int expectedYear, String expectedColor,
			int expectedEngineDisp) {

		this(expectedMake, expectedModel, expectedYear, expectedColor, expectedEngineDisp, null);
	}

	// getters and setters

	public int getEngineDisplacementInCcs() {
		return engineDisplacementInCcs;
	}

	public void setEngineDisplacementInCcs(int engineDisplacementInCcs) {
		this.engineDisplacementInCcs = engineDisplacementInCcs;
	}

	// other methods

	@Override
	public String toString() {
		return "Motorcycle [engineDisplacementInCcs=" + engineDisplacementInCcs + ", toString()=" + super.toString()
				+ "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + engineDisplacementInCcs;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		Motorcycle other = (Motorcycle) obj;
		if (engineDisplacementInCcs != other.engineDisplacementInCcs)
			return false;
		return true;
	}

	@Override
	public double determineAnnualRegistrationFee() {
		double answer = 250;
		if (getEngineDisplacementInCcs() <= 500) {
			answer = 50.00;
		} else if (getEngineDisplacementInCcs() <= 750) {
			answer = 75.00;
		} else if (getEngineDisplacementInCcs() < 1200) {
			answer = 150.00;
		}
		return answer;
	}

}
