package net.ligent.students.transportation;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

public class MotorcycleTest {



	@Test
	public void testNoArgumentConstructor() {
		Motorcycle m1 = new Motorcycle();
		assertNotNull(m1);
	}
	
	@Test
	public void testFullyOverloadedConstructor() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		assertNotNull(m1);
		assertEquals(expectedMake, m1.getMake());
		assertEquals(expectedModel, m1.getModel());
		assertEquals(expectedYear, m1.getYear());
		assertEquals(expectedColor, m1.getColor());
		assertEquals(expectedEngineDisp, m1.getEngineDisplacementInCcs());
		assertEquals(expectedVehicleIdNumber, m1.getVehicleIdNumber());
	}	
	
	@Test
	public void testNoVINOverloadedConstructor() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = null;
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp);
		assertNotNull(m1);
		assertEquals(expectedMake, m1.getMake());
		assertEquals(expectedModel, m1.getModel());
		assertEquals(expectedYear, m1.getYear());
		assertEquals(expectedColor, m1.getColor());
		assertEquals(expectedEngineDisp, m1.getEngineDisplacementInCcs());
		assertEquals(expectedVehicleIdNumber, m1.getVehicleIdNumber());
	}	
	
	@Test
	public void testToString() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		String expected = "Motorcycle [engineDisplacementInCcs=700, toString()=Vehicle [make=Indian, model=Respect, year=1965, color=Red, vehicleIdNumber=X1234567]]";
		String actual = m1.toString();
		assertEquals(expected, actual);
	}
	
	@Test
	public void testEqualsAllFieldsEqual() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		Motorcycle m2 = new Motorcycle(expectedMake,
                expectedModel,
                expectedYear,
                expectedColor,
                expectedEngineDisp,
                expectedVehicleIdNumber);
		assertTrue(m1.equals(m2));
		assertFalse(m1 == m2);
	}
	
	@Test
	public void testEqualsAllFieldsEqualExceptVIN() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		Motorcycle m2 = new Motorcycle(expectedMake,
                expectedModel,
                expectedYear,
                expectedColor,
                expectedEngineDisp,
                "Y987654");
		assertTrue(m1.equals(m2));
		assertFalse(m1 == m2);
	}
	
	@Test
	public void testEqualsAllFieldsEqualExceptMake() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle("Harley-Davidson",
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		Motorcycle m2 = new Motorcycle(expectedMake,
                expectedModel,
                expectedYear,
                expectedColor,
                expectedEngineDisp,
                expectedVehicleIdNumber);
		assertFalse(m1.equals(m2));
		assertFalse(m1 == m2);
	}
	
	
	@Test
	public void testEqualsAllFieldsEqualExceptModel() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		Motorcycle m2 = new Motorcycle(expectedMake,
                "Lightning",
                expectedYear,
                expectedColor,
                expectedEngineDisp,
                expectedVehicleIdNumber);
		assertFalse(m1.equals(m2));
		assertFalse(m1 == m2);
	}
	
	@Test
	public void testEqualsAllFieldsEqualExceptYear() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		Motorcycle m2 = new Motorcycle(expectedMake,
				expectedModel,
                2016,
                expectedColor,
                expectedEngineDisp,
                expectedVehicleIdNumber);
		assertFalse(m1.equals(m2));
		assertFalse(m1 == m2);
	}
	
	@Test
	public void testEqualsAllFieldsEqualExceptColor() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		Motorcycle m2 = new Motorcycle(expectedMake,
				expectedModel,
				expectedYear,
                "Blue",
                expectedEngineDisp,
                expectedVehicleIdNumber);
		assertFalse(m1.equals(m2));
		assertFalse(m1 == m2);
	}
	
	@Test
	public void testEqualsAllFieldsEqualExceptEngineDisp() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 700;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		Motorcycle m2 = new Motorcycle(expectedMake,
				expectedModel,
				expectedYear,
				expectedColor,
                350,
                expectedVehicleIdNumber);
		assertFalse(m1.equals(m2));
		assertFalse(m1 == m2);
	}
	
	@Test
	public void testDetermineAnnualRegistrationFee500CC() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 500;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		double expectedFee = 50.00;
		double actualFee = m1.determineAnnualRegistrationFee();
		assertEquals(expectedFee, actualFee, 0.005);
	}
	
	
	@Test
	public void testDetermineAnnualRegistrationFee750CC() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 750;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		double expectedFee = 75.00;
		double actualFee = m1.determineAnnualRegistrationFee();
		assertEquals(expectedFee, actualFee, 0.005);
	}
	
	
	@Test
	public void testDetermineAnnualRegistrationFee1199CC() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 1199;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		double expectedFee = 150.00;
		double actualFee = m1.determineAnnualRegistrationFee();
		assertEquals(expectedFee, actualFee, 0.005);
	}
	

	@Test
	public void testDetermineAnnualRegistrationFee1200CC() {
		String expectedMake = "Indian";
		String expectedModel = "Respect";
		int expectedYear = 1965;
		String expectedColor = "Red";
		int expectedEngineDisp = 1200;
		String expectedVehicleIdNumber = "X1234567";
		Motorcycle m1 = new Motorcycle(expectedMake,
				                       expectedModel,
				                       expectedYear,
				                       expectedColor,
				                       expectedEngineDisp,
				                       expectedVehicleIdNumber);
		double expectedFee = 250.00;
		double actualFee = m1.determineAnnualRegistrationFee();
		assertEquals(expectedFee, actualFee, 0.005);
	}	

}
